__tmp_reg__	= 0
__zero_reg__	= 1

SPMCSR		= 87 - 32

SPMEN		= 0
PGERS		= 1
PGWRT		= 2
BLBSET		= 3
RWWSRE		= 4
RWWSB		= 6

;.section	.bootloader
	.text
.global	spm_calls
	rjmp	page_fill
	rjmp	page_write
	rjmp	page_erase
	rjmp	lock_bits_set
	rjmp	bad_call
	rjmp	bad_call

	.type	page_write, @function
page_write:
	rcall	spm_wait
	movw	r30,r24
	ldi	r18,5
	out	SPMCSR,r18
	spm
	rcall	spm_wait
	rjmp	rww_enable
	.size	page_write, .-page_write

	.type	page_erase, @function
page_erase:
	rcall	spm_wait
	movw	r30,r24
	ldi	r18,3
	out	SPMCSR,r18
	spm
	rcall	spm_wait
	rjmp	rww_enable
	.size	page_erase, .-page_erase

	.type	page_fill, @function
page_fill:
	movw	r30,r24
	movw	r0,r22
	ldi	r18,1
	out	SPMCSR,r18
	spm
	eor	r1,r1
	rjmp	spm_wait
	.size	page_fill, .-page_fill

	.type	lock_bits_set, @function
lock_bits_set:
	rcall	spm_wait
	mov	__tmp_reg__,r24
	ldi	r18, 9
	out	SPMCSR,r18
	spm
	rjmp	spm_wait
	.size	lock_bit_set, .-lock_bit_set

	.type	spm_wait, @function
spm_wait:
1:
	in __tmp_reg__, SPMCSR
	sbrc __tmp_reg__,SPMEN
	rjmp 1b
	ldi	r24,0
	ret
	.size	spm_wait, .-spm_wait

	.type	rww_wait, @function
rww_wait:
1:
	in	__tmp_reg__,SPMCSR
	sbrc	__tmp_reg__,RWWSB
	rjmp	1b
	ldi	r24,0
	ret
	.size	rww_wait, .-rww_wait

	.type	rww_enable, @function
rww_enable:
	rcall	spm_wait
	movw	r30,r24
	ldi	r18,11
	out	SPMCSR,r18
	spm
	rjmp	spm_wait
	.size	rww_enable, .-rww_enable


	.type	bad_call, @function
bad_call:
	ldi	r24,1
	ret
	.size	bad_call, .-bad_call
