__tmp_reg__	= 0
__zero_reg__	= 1

DFU_PAGE_WRITE		= 0x1ffa
DFU_PAGE_ERASE		= 0x1ffc
DFU_PAGE_FILL		= 0x1ff8
DFU_LOCK_BITS_SET	= 0x1ffe

;1FF8 : 940C 1EA4    JMP     L1EA4 ; page_fill(addr, data);
;1FFA : 940C 1E75    JMP     L1E75 ; page_write(addr); 
;1FFC : 940C 1E86    JMP     L1E86 ; page_erase(addr); 
;1FFE : 940C 1EAC    JMP     L1EAC ; lock_bits_set(lock_bits)

	.text
.global	dfu_page_write
	.type	dfu_page_write, @function
dfu_page_write:
	push	r17
	push	r16
	movw	r16, r24
	.dc.w	0x940c			; call
	.dc.w	DFU_PAGE_WRITE
	pop	r16
	pop	r17
	eor	r1,r1
	ret
	.size	dfu_page_write, .-dfu_page_write

.global	dfu_page_erase
	.type	dfu_page_erase, @function
dfu_page_erase:
	push	r17
	push	r16
	movw	r16, r24
	.dc.w	0x940c			; call
	.dc.w	DFU_PAGE_ERASE
	pop	r16
	pop	r17
	eor	r1,r1
	ret
	.size	dfu_page_erase, .-dfu_page_erase

.global	dfu_page_fill
dfu_page_fill:
	push	r17
	push	r16
	movw	r18, r24
	movw	r16, r26
	.dc.w	0x940c			; call
	.dc.w	DFU_PAGE_FILL
	pop	r16
	pop	r17
	eor	r1,r1
	ret
	.size	dfu_page_fill, .-dfu_page_fill

